
/*********************************************************************
*                                                                    *
*                       Software License Agreement                   *
*                                                                    *
*   The software supplied herewith by Microchip Technology           *
*   Incorporated (the "Company") for its PICmicro Microcontroller   *
*   is intended and supplied to you, the Companys customer, for use *
*   solely and exclusively on Microchip PICmicro Microcontroller     *
*   products. The software is owned by the Company and/or its        *
*   supplier, and is protected under applicable copyright laws. All  *
*   rights are reserved. Any use in violation of the foregoing       *
*   restrictions may subject the user to criminal sanctions under    *
*   applicable laws, as well as to civil liability for the breach of *
*   the terms and conditions of this license.                        *
*                                                                    *
*   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           *
*   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    *
*   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    *
*   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     *
*   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  *
*   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  *
*                                                                    *
*********************************************************************/

/*********************************************************************
*                                                                    *
*   Filename:	    mstri2c.h                                        *
*   Date:           06/09/2000                                       *
*   Revision:       1.00                                             *
*                                                                    *
*   Tools:          MPLAB 5.00.00                                    *
*                   Hi-Tech PIC C Compiler V7.85                     *
*                                                                    *
*********************************************************************/






#define MaxNumberI2CSlaves    12         // maximum number of I2C slave devices
#define OperNumberI2CSlaves   12         // operational number of I2C slaves

#define MaxChannelsPerSlave   12         // maximum channels of data per slave
#define OperChannelsPerSlave   3         // operational number of channels of data

#define MaxLength2PC  10



// FUNCTION PROTOTYPES

/* Functions defined in init.c file  */
extern void Init_Ports( void );
extern void Init_Ssp( void );
extern void Init_Usart( void ); 
extern void Init_Timer1( void );

/* Functions defined in i2c_comm.c file  */
extern void Service_I2CSlave( void );


// VARIABLES ( DECLARED HERE )

/* Variables defined in i2c_comm.c file  */
extern unsigned char read_count;
extern unsigned char index;

extern bank1 unsigned char ReadStatBufFromSlave[OperChannelsPerSlave+8];  
extern const unsigned char *I2CState_Ptr;


/* Variables defined in i2c_comm.c file  */
extern unsigned char slave_count;



// VARIABLES ( DEFINED HERE )

union events {
		unsigned int status;                   // entire status word
		struct bit_events {                    // structure with 8 bits
            unsigned int usart_tx         :1;  // flag indicating USART transmit event 
            unsigned int                  :1;  // 
			unsigned int i2c              :1;  // flag indicating I2C event
			unsigned int                  :1;  //
			unsigned int                  :1;  // 
            unsigned int write_state      :1;  // flag indicating write state entered
			unsigned int writes_done      :1;  // flag indicating that write state done 
            unsigned int                  :1;  // 
			unsigned int                  :1;  // 
			unsigned int                  :1;  // 
			unsigned int next_i2cslave    :1;  // flag indicating service next slave		
			unsigned int read_loop        :1;  // flag indicating read loop in progress  
			unsigned int read_start       :1;  // flag indicating read state entered
            unsigned int reads_done       :1;  // flag indicating that read state is done 
            unsigned int read_i2c         :1;  // flag indicating I2C read state  
            unsigned int                  :1;  //  
        } event;
} sflag;   


union i2c_error_events {
		unsigned char status;   
		struct error_events {                  // structure with 16 bits
            unsigned int slave_override    :1; // flag indicating 
            unsigned int retry_attempt     :1; // flag indicating to retry I2C comm
			unsigned int                   :1; // 
			unsigned int                   :1; //
			unsigned int                   :1; //  
			unsigned int overlimit         :1; // flag indicating byte is out-of-range
            unsigned int ack_error         :1; // flag indicating acknowledge error
            unsigned int bus_coll_error    :1; // flag indicating bus collision error
		} i2c;
} eflag;
